﻿using System;
using System.IO;
using System.Collections.Generic;

namespace sorozatok
{
  class Film
  {
    public string Datum { get; set; }
    public string Nev { get; set; }
    public string Epizod { get; set; }
    public int Perc { get; set; }
    public int Latta { get; set; }
    private int ev, ho, nap;
    public Film(string datum, string nev, string epizod, string perc, string latta)
    {
      Datum = datum;
      Nev = nev;
      Epizod = epizod;
      Perc = int.Parse(perc);
      Latta = int.Parse(latta);
      if (datum != "NI")
      {
        string[] bonto = datum.Split('.');
        ev = int.Parse(bonto[0]);
        ho = int.Parse(bonto[1]);
        nap = int.Parse(bonto[2]);
      }
      else
      {
        ev = ho = nap = 0;
      }
    }

    public string hetnapja()
    {
      string[] napok = { "v", "h", "k", "sze", "cs", "p", "szo" };
      int[] honapok = { 0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4 };
      if (ho < 3) ev -= 1;
      return napok[(ev + ev / 4 - ev / 100 + ev / 400 + honapok[ho - 1] + nap) % 7];
    }

    public string hetnapja(int ev, int ho, int nap)
    {
      string[] napok = { "v", "h", "k", "sze", "cs", "p", "szo" };
      int[] honapok = { 0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4 };
      if (ho < 3) ev -= 1;
      return napok[(ev + ev / 4 - ev / 100 + ev / 400 + honapok[ho - 1] + nap) % 7];
    }
  }

  class Program
  {
    static List<Film> Lista = new();
    static void Main()
    {
      F1beolvas();
      Console.WriteLine("2. feladat");
      Console.WriteLine($"\tA listában {F2db()} db vetítési dátummal rendelkező epizód van.");
      Console.WriteLine("3. feladat");
      Console.WriteLine($"\tA listában lévő epizódok {F3latta():P2}-át látta.");
      Console.WriteLine("4. feladat");
      int osszido = F4percek();
      int nap = osszido / (60 * 24);
      int ora = osszido % (60 * 24) / 60;
      int perc = osszido % 60;
      Console.WriteLine($"\tSorozatnézéssel {nap} napot {ora} órát és {perc} percet töltött.");
      Console.WriteLine("5. feladat");
      Console.Write("Adjon meg egy dátumot! Dátum: ");
      string datum = Console.ReadLine();
      F5kimaradt(datum);
      Console.WriteLine("7. feladat");
      Console.Write("Adja meg a hét egy napját (például cs)! Nap: ");
      string hetnapja = Console.ReadLine();
      F7napi(hetnapja);
      F8summa();
    }

    private static void F8summa()
    {
      StreamWriter sw = new("summa.txt");
      int sum = 0;
      int db = 0;
      for (int i = 0; i < Lista.Count - 1; i++)
      {
        sum += Lista[i].Perc;
        db++;
        if (Lista[i].Nev != Lista[i + 1].Nev)
        {
          sw.WriteLine($"{Lista[i].Nev} {sum} {db}");
          sum = 0;
          db = 0;
        }
      }
      sum += Lista[^1].Perc;
      /*[Lista.Count - 1] helyett hátulról indexelés [^1]*/
      db++;
      sw.WriteLine($"{Lista[^1].Nev} {sum} {db}");
      
      sw.Close();
    }

    private static void F7napi(string hetnapja)
    {
      List<string> napifilm = new();
      foreach (Film film in Lista)
      {
        if (film.Datum != "NI" && film.hetnapja() == hetnapja)
        {
          int i;
          for (i = 0; i < napifilm.Count && napifilm[i] != film.Nev; i++)
            ;
          if (i == napifilm.Count)
            napifilm.Add(film.Nev);
        }
      }
      if (napifilm.Count == 0)
        Console.WriteLine("Az adott napon nem kerül adásba sorozat.");
      else
        foreach (string cim in napifilm)
          Console.WriteLine(cim);
    }

    private static void F5kimaradt(string datum)
    {
      foreach (Film film in Lista)
        if (film.Datum != "NI" && film.Latta == 0 && datum.CompareTo(film.Datum) >= 1)
          Console.WriteLine($"\t{film.Epizod}\t{film.Nev}");
    }

    private static int F4percek()
    {
      int szum = 0;
      foreach (Film film in Lista)
        if (film.Latta == 1)
          szum += film.Perc;
      return szum;
    }

    private static double F3latta()
    {
      int db = 0;
      foreach (Film film in Lista)
        db+=film.Latta;
      return (double)db/Lista.Count;
    }

    private static int F2db()
    {
      int db = 0;
      foreach (Film film in Lista)
        if (film.Datum != "NI")
           db++;
      return db;
    }

    private static void F1beolvas()
    {
      StreamReader sr = new("lista.txt");
      while (!sr.EndOfStream)
      {
        Lista.Add(new Film(sr.ReadLine(), sr.ReadLine(), sr.ReadLine(), sr.ReadLine(), sr.ReadLine()));
      }
      sr.Close();
    }
  }
}
